#!/bin/sh
#The next line executes wish - wherever it is \
exec wish "$0" "$@"
#
package require Tk
package require Ttk
# Procedures
proc inFile {} {
	global dirIn
	set types {
		{{All Files} * }
	} 
	set filename [tk_getOpenFile -filetypes $types -title "Select Input File"  -initialdir $dirIn]
	.fiLes.fiLes1.textFile delete 0 end
	.fiLes.fiLes1.textFile insert end $filename
	.fiLes.fiLes1.textFile xview [string lengt $filename]
	return
}
proc sFile {} {
	global dirOut
	set filename [tk_getSaveFile -title "Select Output File" -initialdir $dirOut]
	.fiLes.fiLes2.textFile delete 0 end 
	.fiLes.fiLes2.textFile insert end $filename
	.fiLes.fiLes2.textFile xview [string lengt $filename]
	return
}
proc TempFolder {} {
	global tempdir
	if {![file exists $tempdir]} {
		set tempdir "~"
	}
	set dir [tk_chooseDirectory -initialdir $tempdir -title "Choose a directory"]
	.fiLes.vframe.temp delete 0 end
	.fiLes.vframe.temp insert end  $dir
	.fiLes.vframe.temp xview [string lengt $dir]
	return 
}
proc log {} {
	global input ln error_log lang_ok ok_check openFu outF error_run error_programm programm lang_open_file
	if { [gets $input line] > 0 } {
		.log.msg insert end $line\n
		.log.msg see end
		set ln $line
		update
	} elseif { [eof $input] } {
		catch { close $input }
		set newline [split $ln :]
		if {[lindex $newline 0]=="video"} {
			set ok_check 1
		} 
		if {$ok_check==1} {
			.log.msg insert end "$lang_ok\n" blue_color
		} elseif {$ok_check==0 && $error_run==0} {
			.log.msg insert end "$error_log\n" red_color	
		}
		if {$openFu==1 && [file exists $outF] && $error_run!=1} {
			if {$programm=="" || ![file exist "/usr/bin/$programm"]} {
				.log.msg insert end "$error_programm\n" red_color
			} elseif  {$ok_check==1} {
				open "|$programm \"$outF\""
				.log.msg insert end "$lang_open_file\n" blue_color
			}
		}
		#.but.go configure -state normal
		.log.msg see end
		Progres "stop"
	}
}
proc go {inpF outF vBit fps chdein x y vcodec acodec freq aBit st} {
	global input ln pi lang_exec error_file error_input_file error_input_file_ex error_output_file error_vbitrate
	global error_x error_y error_fps error_vcodec error_acodec error_freq error_abitrate lang_ok openFu error_run
	global programm lang_abort lang_open_file error_log ok_check lunch
	set error_run 0
	set lunch "go"
	Progres "start"
	.log.msg delete 1.0 end
	#.but.burn configure -state disabled
	.but.go configure -state disabled
	if {$inpF=="" && $outF==""} {Progres "stop";return "$error_file\n"}
	if {$inpF==""} {Progres "stop";return "$error_input_file\n"}
	if {![file exists "$inpF" ]} {Progres "stop";return "$error_input_file_ex\n"}
	if {$outF==""} {Progres "stop";return "$error_output_file\n"}
	if {$chdein==1} {
		set chde {-deinterlace}
	} else {
		set chde {}
	}
	if {$st==1} {
		set chst {-ac 2}
	} else {
		set chst {-ac 1}
	}
	if {$vBit=="" || $vBit==0} {Progres "stop";return "$error_vbitrate\n"}
	if {$x=="" || $x==0} {Progres "stop";return "$error_x\n"}
	if {$y=="" || $y==0} {Progres "stop";return "$error_y\n"}
	if {$fps=="" || $fps==0} {Progres "stop";return "$error_fps\n"}
	if {$vcodec=="" || $vcodec==0} {Progres "stop";return "$error_vcodec\n"}
	if {$acodec=="" || $acodec==0} {Progres "stop";return "$error_acodec\n"}
	if {$freq=="" || $freq==0} {Progres "stop";return "$error_freq\n"}
	if {$aBit=="" || $aBit==0} {Progres "stop";return "$error_abitrate\n"}
	if {[file exists "$outF" ]} {
		set chfile "-y"
	} else {
		set chfile ""
	}
	if {$acodec=="mp3"} {
		set acodec "libmp3lame"
	}
	set str "ffmpeg -i \"$inpF\" -b $vBit\k -r $fps $chde -s $x\x$y -vcodec $vcodec $chst -acodec $acodec -ar $freq -ab $aBit\k $chfile \"$outF\""
	set ok_check 0	
	if {[catch {open "|$str |& cat"} input]} {
			.log.msg insert end "$lang_exec $str\n\n" blue_color
		} else {
			set pi [lindex [pid $input] 0]
			fileevent $input readable log
			.log.msg insert end "$lang_exec $str\n\n" blue_color
	}
	catch {fconfigure $input -blocking 0}
	.log.msg see end
}
proc kill {} {
	global pi error_run error_user lunch
	if {$pi!=""} {
		set fill [open "|kill -s kill $pi"]
	}
	set error_run 1
	destroy .progres
	.log.msg insert end "$error_user\n" red_color
	.log.msg see end
	if {$lunch!="go"} {
		.but.burn configure -state active
	}
	.but.go configure -state active
}
proc save_options {} {
	global env programm inpF outF vBit fps dIn vcodec X Y acodec freq aBit stu openFu language version userO rundir tempdir
	if { ! [file exists "$env(HOME)/.Tkffmpeg"]} {exec touch $env(HOME)/.Tkffmpeg}
	set config_file [open $env(HOME)/.Tkffmpeg w]
	puts $config_file "programm = $programm"
	set dirIn [string range $inpF 0 [string last "/" $inpF]]
	puts $config_file "dirIn = $dirIn"
	set dirOut [string range $outF 0 [string last "/" $outF]]
	puts $config_file "dirOut = $dirOut"
	puts $config_file "language = $language"
	puts $config_file "userO = $userO"
	puts $config_file "vBit = $vBit"
	puts $config_file "fps = $fps"
	puts $config_file "dIn = $dIn"
	puts $config_file "vcodec = $vcodec"
	puts $config_file "X = $X"
	puts $config_file "Y = $Y"
	puts $config_file "acodec = $acodec"
	puts $config_file "freq = $freq"
	puts $config_file "aBit = $aBit"
	puts $config_file "stu = $stu"
	puts $config_file "openFu = $openFu"
	puts $config_file "tempdir = $tempdir"
	close $config_file
	file delete -force "$rundir"
	exit
}
proc adv_opt_window {} {
	global language programm lang_use lang_adv_opt lang_change lang_programm lang_userO userO user lang_save_but
	if { ! [winfo exists .adv_opt_window] } {
		toplevel .adv_opt_window
		wm title .adv_opt_window $lang_adv_opt
		wm resizable .adv_opt_window false false
		wm transient .adv_opt_window .
		frame .adv_opt_window.1 -bg #b4d9cf
		label .adv_opt_window.1.llang -text $lang_change -takefocus 0 -font {-size 10} -bg #b4d9cf
		ttk::combobox .adv_opt_window.1.lang -values $lang_use -width 17 -textvariable language -state readonly
		.adv_opt_window.1.lang current [lsearch -exact $lang_use $language]
		frame .adv_opt_window.2 -bg #b4d9cf
		label .adv_opt_window.2.lprog -text $lang_programm -takefocus 0 -font {-size 10} -bg #b4d9cf
		ttk::entry .adv_opt_window.2.prog -width 10 -textvariable programm
		frame .adv_opt_window.3 -bg #b4d9cf
		checkbutton .adv_opt_window.3.userO -variable userO -text $lang_userO -bg #b4d9cf
		frame .adv_opt_window.4 -bg #b4d9cf
		ttk::button .adv_opt_window.4.ok -command {destroy .adv_opt_window} -text $lang_save_but -width 10
		pack .adv_opt_window.1 -fill x
		pack .adv_opt_window.1.llang -side left -padx 5 -pady 2
		pack .adv_opt_window.1.lang -side left -padx {0 5}
		pack .adv_opt_window.2 -fill x
		pack .adv_opt_window.2.lprog -side left -pady 2 -padx 5
		pack .adv_opt_window.2.prog -side left -padx {0 5}
		pack .adv_opt_window.3 -fill x
		pack .adv_opt_window.3.userO -side left -pady 2 -padx 5
		pack .adv_opt_window.4 -fill x
		pack .adv_opt_window.4.ok
	}
}
proc file_exist {name} {
	if { [file exists "./$name"] } {
		return "./$name"
	} elseif {[file exists "/usr/share/tkffmpeg/$name"]} {
		return "/usr/share/tkffmpeg/$name"
	}
}
proc lang_list {} {
	global lang_use
	set defFile [file_exist "language"]
	if { [file exists $defFile] } {
		set fl [open "|ls $defFile"]
		while { ! [eof $fl] } {
			gets $fl str
			if {$str!=""} {
				lappend lang_use [file rootname $str]
			}
		}
		close $fl
		#puts $lang_use
	}
}
proc dvdcheck {check} {
	global lang_burn lang_aspect
	if {$check==1} {
		.fiLes.fiLes2.name configure -state disabled
		.fiLes.fiLes2.textFile configure -state disabled
		.fiLes.fiLes2.saveFile configure -state disabled
		.option.optionV.v1.4.label configure -state disabled
		.option.optionV.v1.4.lst configure -state disabled
		.option.optionA.1.lstac configure -state disabled
		.option.optionA.1.ac configure -state disabled
		.but.chop configure -state disabled
		#.option.optionV.v1.1.bitrate configure -state disabled
		#.option.optionV.v1.1.sbitrate configure -state disabled
		#.option.optionV.v1.2.sfps configure -state disabled
		#.option.optionV.v1.2.fps configure -state disabled
		#.option.optionA.2.fr configure -state disabled
		#.option.optionA.2.lstfr configure -state disabled
		#.option.optionA.3.bit configure -state disabled
		#.option.optionA.3.lstbit configure -state disabled
		.but.go configure -command {.log.msg insert end [dvdgo $inpF $vBit $fps $dIn $freq $aBit $stu $aspect] red_color}
		ttk::button .but.burn -command burn -text $lang_burn -width 7 -state disabled
		pack .but.burn -side right -padx {0 5}
		.fiLes.vframe.ltemp configure -state normal
		.fiLes.vframe.temp configure -state normal
		.fiLes.vframe.tempfolder configure -state normal
		destroy .option.optionV.size.2
		destroy .option.optionV.size.3
		#
		ttk::frame .option.optionV.size.2  
		pack .option.optionV.size.2 -pady 5 -fill x -padx 10
		ttk::label .option.optionV.size.2.x -text $lang_aspect -takefocus 0 -font {-size 10}
		pack .option.optionV.size.2.x -fill x
		ttk::combobox .option.optionV.size.2.aspect -values {"4:3" "16:9"} -width 5 -textvariable aspect
		.option.optionV.size.2.aspect current 0		
		pack .option.optionV.size.2.aspect -fill x
	} else {
		.fiLes.fiLes2.name configure -state normal
		.fiLes.fiLes2.textFile configure -state normal
		.fiLes.fiLes2.saveFile configure -state normal
		.option.optionV.v1.4.label configure -state normal
		.option.optionV.v1.4.lst configure -state normal
		.option.optionA.1.lstac configure -state normal
		.option.optionA.1.ac configure -state normal
		.but.chop configure -state normal
		#.option.optionV.v1.1.bitrate configure -state normal
		#.option.optionV.v1.1.sbitrate configure -state normal
		#.option.optionV.v1.2.sfps configure -state normal
		#.option.optionV.v1.2.fps configure -state normal
		.but.go configure -command {.log.msg insert end [go $inpF $outF $vBit $fps $dIn $X $Y $vcodec $acodec $freq $aBit $stu] red_color}
		destroy .but.burn
		.fiLes.vframe.ltemp configure -state disabled
		.fiLes.vframe.temp configure -state disabled
		.fiLes.vframe.tempfolder configure -state disabled
		#.option.optionA.2.fr configure -state normal
		#.option.optionA.2.lstfr configure -state normal
		#.option.optionA.3.bit configure -state normal
		#.option.optionA.3.lstbit configure -state normal
		#
		destroy .option.optionV.size.2
		ttk::frame .option.optionV.size.2  
		pack .option.optionV.size.2 -pady 5 -fill x -padx 10
		spinbox .option.optionV.size.2.sx -from 10 -to 1024 -increment 2 -width 5 -textvariable X
		ttk::label .option.optionV.size.2.x -text "X" -takefocus 0 -font {-size 10}
		pack .option.optionV.size.2.sx -side left
		pack .option.optionV.size.2.x -side left -padx {5 0}
		ttk::frame .option.optionV.size.3  
		pack .option.optionV.size.3 -pady 5 -fill x -padx 10
		spinbox .option.optionV.size.3.sy -from 10 -to 1024 -increment 2 -width 5 -textvariable Y
		ttk::label .option.optionV.size.3.y -text "Y" -takefocus 0 -font {-size 10}
		pack .option.optionV.size.3.sy -side left
		pack .option.optionV.size.3.y -side left -padx {5 0}
	}
}
proc burn {} {
	global env lang_exec lang_ok rundir error_size
	Progres "start"
	.but.burn configure -state disabled
	.but.go configure -state disabled
	set fn [open "|du -b $rundir"]
	while {![eof $fn]} {
		if { [gets $fn line] > 0 } {
			if {[lindex $line end]==$rundir} {
				set sizedir [lindex $line 0]
			}
		}
		update
	}
	if {$sizedir<4700307456} {
		set str "growisofs -Z /dev/dvd -dvd-video $rundir"
		.log.msg insert end "$lang_exec $str\n\n" blue_color
		set fn [open "|$str |& cat"]
		fconfigure $fn -blocking 0
		while {![eof $fn]} {
			if { [gets $fn line] > 0 } {
				.log.msg insert end $line\n
				.log.msg see end
			}
			update
		}
		close $fn
		.log.msg insert end "$lang_ok\n" blue_color
	} else {
		.log.msg insert end "$error_size\n" red_color
	}
	.but.burn configure -state normal
	.but.go configure -state normal
	.log.msg see end
	Progres "stop"
}
proc logdvd {} {
	global input ln error_log lang_ok ok_check error_run lang_exec
	if { [gets $input line] > 0 } {
		.log.msg insert end $line\n
		.log.msg see end
		set ln $line
		update
	} elseif { [eof $input] } {
		catch { close $input }
		if {[lindex $ln 3]=="VOBUS"} {
			set ok_check 1
		}
		if {$ok_check==1} {
			.log.msg insert end "$lang_ok\n" blue_color
			set str "dvdauthor -o . -T"
			.log.msg insert end "$lang_exec $str\n\n" blue_color
			set fn [open "|$str |& cat"]
			fconfigure $fn -blocking 0
			while {![eof $fn]} {
				if { [gets $fn line] > 0 } {
					.log.msg insert end $line\n
					.log.msg see end
				}
				update
			}
			close $fn
			.log.msg insert end "$lang_ok\n" blue_color
		} elseif {$ok_check==0 && $error_run==0} {
			.log.msg insert end "$error_log\n" red_color	
		}
		.but.burn configure -state active
		.log.msg see end
		Progres "stop"
	}
}

#Convert the DVD-video
proc dvdgo {inpF vBit fps chdein freq aBit st aspect} {
#dvdgo $inpF $outF $vBit $fps $dIn $freq $aBit $stu
	global pi lang_exec error_input_file error_input_file_ex error_vbitrate tempdir rundir
	global error_x error_y error_fps error_freq error_abitrate error_log lang_ok error_run
	global input ln ok_check lunch
	set error_run 0
	set lunch "dvdgo"
	Progres "start"
	.log.msg delete 1.0 end
	.but.burn configure -state disabled
	.but.go configure -state disabled
	if {$inpF==""} {Progres "stop";return "$error_input_file\n"}
	if {$vBit=="" || $vBit==0} {Progres "stop";return "$error_vbitrate\n"}
	if {![file exists "$inpF" ]} {Progres "stop";return "$error_input_file_ex\n"}
	if {$chdein==1} {
		set chde {-deinterlace}
	} else {
		set chde {}
	}
	if {$st==1} {
		set chst {-ac 2}
	} else {
		set chst {-ac 1}
	}
	if {$vBit=="" || $vBit==0} {Progres "stop";return "$error_vbitrate\n"}
	if {$fps=="" || $fps==0} {Progres "stop";return "$error_fps\n"}
	if {$freq=="" || $freq==0} {Progres "stop";return "$error_freq\n"}
	if {$aBit=="" || $aBit==0} {Progres "stop";return "$error_abitrate\n"}
	set rundir "$tempdir/tkffmpeg"
	file delete -force "$rundir"
	file mkdir "$rundir"
	cd "$rundir"
	set str "ffmpeg -i \"$inpF\" -b $vBit\k -r $fps $chde -s 720x576 -aspect $aspect -vcodec mpeg2video $chst -acodec libmp3lame -ar $freq -ab $aBit\k -f dvd - | dvdauthor -o . -t -"
	#set str "ffmpeg -i \"$inpF\" -b $vBit\k -r $fps $chde -s $x\x$y -vcodec $vcodec $chst -acodec $acodec -ar $freq -ab $aBit\k $chfile \"$outF\""
	set ok_check 0
	if {[catch {open "|$str |& cat"} input]} {
			.log.msg insert end "$lang_exec $str\n\n" blue_color
		} else {
			set pi [lindex [pid $input] 1]
			fileevent $input readable logdvd
			.log.msg insert end "$lang_exec $str\n\n" blue_color
	}
	catch {fconfigure $input -blocking 0}
	.log.msg see end
}
proc Progres {value} {
	global error_run lang_abort error_user
	if {$value=="start"} {
		set w .progres
		toplevel $w
		wm title $w "Operation in progress"
		wm iconname $w "tkffmpeg"
		wm resizable $w false false
		wm geometry $w 300x70
		wm transient $w .
		pack [ttk::frame $w.prog] -fill x -pady {0 5} -padx 10
		ttk::progressbar $w.prog.p2 -mode indeterminate ;#-variable i
		pack $w.prog.p2 -padx 20 -fill x -expand 1 -pady 10
		ttk::button $w.prog.but -command kill -text $lang_abort -width 10 
		pack $w.prog.but -anchor center
		$w.prog.p2 start
	} else {
		if {$error_run!=1} {
			destroy .progres
		}
		.but.go configure -state active
	}
}
#Main program
lang_list
# Set variable
set dirIn ""
set dirOut ""
set inpF ""
set outF ""
set pi ""
set user 0
set dvd 0
set error_run 0
set tempdir "/home/$env(USER)/tmp"
set rundir ""
#Bind key
bind all <Control-q> {kill} 
#Load default.ini
set defFile [file_exist "default.ini"]
if { [file exists $defFile] } {
	set config_file [open $defFile r]
	while { ! [eof $config_file] } {
		gets $config_file string_temp
		set [lindex $string_temp 0] [lrange $string_temp 2 end]
	}
	close $config_file
}
#Load saved options
if { [file exists "$env(HOME)/.Tkffmpeg"] } {
	set config_file [open $env(HOME)/.Tkffmpeg r]
	while { ! [eof $config_file] } {
		gets $config_file string_temp
		if {[lindex $string_temp end]!="=" && [lindex $string_temp end]!="-1"} {set [lindex $string_temp 0] [lrange $string_temp 2 end]}

		if {[lindex $string_temp 0]=="userO" && [lindex $string_temp end]==0} {break}
	}
	close $config_file
}
#Loading linguistic variables
set defFile [file_exist "language/english.lng"]
if { [file exists $defFile] } {
	set config_file [open $defFile r]
	while { ! [eof $config_file] } {
		gets $config_file string_temp
		set [lindex $string_temp 0] [lrange $string_temp 2 end]
	}
	close $config_file
}
set defFile [file_exist "language/$language.lng"]
if { [file exists $defFile] } {
	set config_file [open $defFile r]
	while { ! [eof $config_file] } {
		gets $config_file string_temp
		set [lindex $string_temp 0] [lrange $string_temp 2 end]
	}
	close $config_file
}
#Window settings
wm title . "$lang_title $version"
wm iconname . "tkffmpeg"
wm geometry . 575x415
wm resizable . false false
wm protocol . WM_DELETE_WINDOW { save_options }
ttk::style theme use alt
#GUI
ttk::label .ffmpeg -text $lang_title -justify center -takefocus 0 -font {-size 22} -anchor center
pack .ffmpeg -fill x -ipady 15
# Sections Files
ttk::labelframe .fiLes -text $lang_title_files
ttk::frame .fiLes.fiLes1
ttk::frame .fiLes.fiLes2
ttk::label .fiLes.fiLes1.name -text $lang_input_file -takefocus 0 -font {-size 10} -width 9
ttk::label .fiLes.fiLes2.name -text $lang_output_file -takefocus 0 -font {-size 10} -width 9
entry .fiLes.fiLes1.textFile -width 54 -textvariable inpF
.fiLes.fiLes1.textFile insert end $dirIn
.fiLes.fiLes1.textFile xview [string lengt $dirIn]
entry .fiLes.fiLes2.textFile -width 54 -textvariable outF
.fiLes.fiLes2.textFile insert end $dirOut
.fiLes.fiLes2.textFile  xview [string lengt $dirOut]
ttk::button .fiLes.fiLes1.inputFile -command inFile -width 2 -text ...
ttk::button .fiLes.fiLes2.saveFile -command sFile -width 2 -text ...
#
frame .fiLes.vframe -bg #b4d9cf
checkbutton .fiLes.vframe.dvdvideo -variable dvd -text $lang_dvd_check -width 17 -anchor w -command {dvdcheck $dvd} -bg #b4d9cf
ttk::label .fiLes.vframe.ltemp -text $lang_dvd_temp -state disabled -width 16 -anchor e -takefocus 0 -font {-size 10} -background #b4d9cf
entry .fiLes.vframe.temp -width 28 -textvariable tempdir -state disabled
ttk::button .fiLes.vframe.tempfolder -command TempFolder -width 2 -state disabled -text ... 
.fiLes.vframe.temp xview [string lengt $tempdir]
#
pack .fiLes -fill x -pady 10 -padx 5
pack .fiLes.fiLes1 -fill x
pack .fiLes.fiLes1.name -side left -padx 5 
pack .fiLes.fiLes1.textFile -side left -padx 5
pack .fiLes.fiLes1.inputFile -side left -padx {0 5}
pack .fiLes.vframe -fill x -pady {0 5}
pack .fiLes.vframe.dvdvideo -side left
pack .fiLes.vframe.ltemp -side left -padx {0 5}
pack .fiLes.vframe.temp -side left -padx {0 5}
pack .fiLes.vframe.tempfolder -side left -padx {0 5} -pady 2
pack .fiLes.fiLes2 -fill x -pady {0 5}
pack .fiLes.fiLes2.name -side left -padx 5
pack .fiLes.fiLes2.textFile -side left -padx 5
pack .fiLes.fiLes2.saveFile -side left -padx {0 5}
# Section options
ttk::frame .option
ttk::labelframe .option.optionV -text $lang_title_video
ttk::labelframe .option.optionA -text $lang_title_audio
pack .option -fill x
pack .option.optionV -side left -padx 5 -pady 2 -fill both -expand 1
pack .option.optionA -side left -padx {0 5} -pady 2 -fill both -expand 1
#
ttk::frame .option.optionV.v1
pack .option.optionV.v1 -side left -pady 5
ttk::frame .option.optionV.v1.1
pack .option.optionV.v1.1 -fill x -padx 5
spinbox .option.optionV.v1.1.sbitrate -from 50 -to 10000 -width 7 -textvariable vBit
ttk::label .option.optionV.v1.1.bitrate -text $lang_video_bitrate -takefocus 0 -font {-size 10}
pack .option.optionV.v1.1.sbitrate -side left
pack .option.optionV.v1.1.bitrate -side left -padx {5 0}
ttk::frame .option.optionV.v1.2  
pack .option.optionV.v1.2 -pady 5 -fill x -padx 5
spinbox .option.optionV.v1.2.sfps -from 5.0 -to 35.0 -increment 0.5 -width 18 -textvariable fps
ttk::label .option.optionV.v1.2.fps -text $lang_fps -takefocus 0 -font {-size 10}
pack .option.optionV.v1.2.sfps -side left
pack .option.optionV.v1.2.fps -side left -padx {5 0}
ttk::frame .option.optionV.v1.3
pack .option.optionV.v1.3 -fill x -padx 5 -pady {0 5}
ttk::checkbutton .option.optionV.v1.3.chdein -variable dIn -text $lang_deinterlace
pack .option.optionV.v1.3.chdein -side left
ttk::frame .option.optionV.v1.4
pack .option.optionV.v1.4 -fill x -pady {0 5} -padx 5
ttk::combobox .option.optionV.v1.4.lst -values $vcodecS -width 18 -textvariable vcodec
if {[lsearch -exact $vcodecS $vcodec]!=-1} {
	.option.optionV.v1.4.lst current [lsearch -exact $vcodecS $vcodec]
} else {.option.optionV.v1.4.lst current 1}
ttk::label .option.optionV.v1.4.label -text $lang_videocodec -takefocus 0 -font {-size 10}
pack .option.optionV.v1.4.lst -side left
pack .option.optionV.v1.4.label -side left -padx {5 0}
#
ttk::labelframe .option.optionV.size -text $lang_size
pack .option.optionV.size -side left -padx 5 -anchor nw
ttk::frame .option.optionV.size.2  
pack .option.optionV.size.2 -pady 5 -fill x -padx 10
spinbox .option.optionV.size.2.sx -from 10 -to 1024 -increment 2 -width 5 -textvariable X
ttk::label .option.optionV.size.2.x -text "X" -takefocus 0 -font {-size 10}
pack .option.optionV.size.2.sx -side left
pack .option.optionV.size.2.x -side left -padx {5 0}
ttk::frame .option.optionV.size.3  
pack .option.optionV.size.3 -pady 5 -fill x -padx 10
spinbox .option.optionV.size.3.sy -from 10 -to 1024 -increment 2 -width 5 -textvariable Y
ttk::label .option.optionV.size.3.y -text "Y" -takefocus 0 -font {-size 10}
pack .option.optionV.size.3.sy -side left
pack .option.optionV.size.3.y -side left -padx {5 0}
#
ttk::frame .option.optionA.1 
pack .option.optionA.1 -padx 10 -pady {5 0} -fill x
ttk::label .option.optionA.1.ac -text $lang_audiocodec -takefocus 0 -font {-size 10}
ttk::combobox .option.optionA.1.lstac -values $acodecS -width 5 -textvariable acodec
if {[lsearch -exact $acodecS $acodec]!=-1} {
	.option.optionA.1.lstac current [lsearch -exact $acodecS $acodec]
} else {.option.optionA.1.lstac current 0}
pack .option.optionA.1.lstac -side left
pack .option.optionA.1.ac -side left -padx {5 0}
ttk::frame .option.optionA.2 
pack .option.optionA.2 -padx 10 -pady {10 0} -fill x
ttk::label .option.optionA.2.fr -text $lang_frequency -takefocus 0 -font {-size 10}
ttk::combobox .option.optionA.2.lstfr -values $freqS -width 5 -textvariable freq
if {[lsearch -exact $freqS $freq]!=-1} {
	.option.optionA.2.lstfr current [lsearch -exact $freqS $freq]
} else {.option.optionA.2.lstfr current 1}
pack .option.optionA.2.lstfr -side left
pack .option.optionA.2.fr -side left -padx {5 0}
ttk::frame .option.optionA.3 
pack .option.optionA.3 -padx 10 -pady {10 0} -fill x
ttk::label .option.optionA.3.bit -text $lang_audio_bitrate -takefocus 0 -font {-size 10}
ttk::combobox .option.optionA.3.lstbit -values $aBitS -width 5 -textvariable aBit
if {[lsearch -exact $aBitS $aBit]!=-1} {
	.option.optionA.3.lstbit current [lsearch -exact $aBitS $aBit]
} else {.option.optionA.3.lstbit current 3}
pack .option.optionA.3.lstbit -side left
pack .option.optionA.3.bit -side left -padx {5 0}
ttk::frame .option.optionA.4 
pack .option.optionA.4 -padx 10 -pady {10 5} -fill x
ttk::checkbutton .option.optionA.4.chst -variable stu -text $lang_stereo
pack .option.optionA.4.chst -side left
#
frame .but -bg #b4d9cf
checkbutton .but.chop -variable openFu -text $lang_open -bg #b4d9cf
ttk::button .but.go -command {.log.msg insert end [go $inpF $outF $vBit $fps $dIn $X $Y $vcodec $acodec $freq $aBit $stu] red_color} -text $lang_run_but -width 7
ttk::button .but.cancel -command {save_options} -text $lang_exit_but -width 7
ttk::button .but.option -command {adv_opt_window} -text $lang_options_but -width 10
pack .but -fill x
pack .but.chop -side left -padx {5 5}
pack .but.cancel -side right -padx {5 5} -pady 2
pack .but.go -side right -padx {5 5}
pack .but.option -side right -padx 5

pack [frame .log] -fill x
text .log.msg -heigh 3 -yscrollcommand {.log.scroll set} 
.log.msg tag configure red_color -foreground red
.log.msg tag configure blue_color -foreground blue -font "bold"
scrollbar .log.scroll  -command {.log.msg yview}
pack .log.msg -fill both -side left
pack .log.scroll -fill y -side right